//+------------------------------------------------------------------+
//|                                                  CandleBreak.mq4 |
//|                                                         SnowBars |
//|                           https://www.mql5.com/ru/users/snowbars |
//+------------------------------------------------------------------+
#property copyright "SnowBars"
#property link      "https://www.mql5.com/ru/users/snowbars"
#property version   "1.00"
#property strict
enum orderstype {Buy_and_Sell,Buy_Orders,Sell_Orders};
input string Txt0 = "----------------->   <----------------";// ----------------------------------------------------------->   
input bool Autotrade = true;
input double ProcClose = 20;//    % 
input string Txt1 = "--------------->   <----------------";// ----------------------------------------------------------->   
input string Txt2 = "---------------->   <-------------------";// ----------------------------------------------------------->
input orderstype OrdersType = Buy_and_Sell;
input int MaxOrders = 10;
input double AutoProcent = 1;// (%)   (0- )
input double LotManual = 0.05;//  
input int TakeProfit = 0;
input int StopLoss = 0;
input int Slip = 3;
input int SpreadLimit = 50;// Max  Spread
input int MagicNumber = 1234;
input string Txt3 = "---------------->   <----------------";// ----------------------------------------------------------->
input int StopLoss2 = 0;//  /(0-)
input int BU = 0;// (+/-)(0- )
input int StepT = 50;// TrailingStep (0-TrailingOff)
input string Txt4 = "------------------->  ADX <-------------------";// ----------------------------------------------------------->
input int PeriodADX = 14;// Period ADX 
input ENUM_APPLIED_PRICE PriceADX = PRICE_CLOSE;// Price ADX 
input double uslADX = 20;// ADX    
input string Txt5 = "--------------->  MA 1 FAST <-----------------";// ----------------------------------------------------------->
input int MA1Period = 14;
input ENUM_MA_METHOD MA1Method = MODE_SMA;
input ENUM_APPLIED_PRICE MA1Price = PRICE_CLOSE;
input string Txt6 = "-------------->  MA 2 MIDDLE <----------------";// ----------------------------------------------------------->
input int MA2Period = 21;
input ENUM_MA_METHOD MA2Method = MODE_SMA;
input ENUM_APPLIED_PRICE MA2Price = PRICE_CLOSE;
input string Txt7 = "--------------->  MA 3 SLOW <-----------------";// ----------------------------------------------------------->
input int MA3Period = 50;
input ENUM_MA_METHOD MA3Method = MODE_SMA;
input ENUM_APPLIED_PRICE MA3Price = PRICE_CLOSE;
//---
// 
double MA1[5],MA2[5],MA3[5],OrderIndentNorm,OrderStepNorm,StopLossNorm,StopLoss2Norm,BUNorm,PipsPendingOrderNorm,AutoProcentNorm,TakeProfitNorm,StepTNorm,Lot;
int okS,okB,n,nn,s,ss,sl,b,bs,bl,no,SlipNorm,fB,fCls,fError;
string MQL_name,name;
//---
double TeloPips,Telo,UpTeloPips,UpTelo,DownTeloPips,DownTelo;
//---
// 
datetime T,TCls;
int f,ff;
double ClsLot;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
ff=1;
ChartSetInteger(0,CHART_MODE,CHART_CANDLES);
ChartSetInteger(0,CHART_SHOW_GRID,false );
ChartSetInteger(0,CHART_SCALE,4);
ChartSetInteger(0,CHART_COLOR_CHART_LINE,clrYellow);
   MQL_name=MQLInfoString(MQL_PROGRAM_NAME);
   TakeProfitNorm=TakeProfit*_Point;
   StopLossNorm=StopLoss*_Point;
   AutoProcentNorm=NormalizeDouble(AutoProcent,2);
      StopLoss2Norm=StopLoss2*_Point;
      BUNorm=BU*_Point;
      StepTNorm=StepT*_Point;
   SlipNorm=Slip;
   LOT();
   onTick();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectsDeleteAll(0,MQL_name);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){onTick();}
void onTick(){
//----
double Proc=AccountBalance()*0.01;
Proc=(AccountBalance()-AccountEquity())/Proc;
if(Proc>ProcClose){fCls=7;}
//---
   if(Time[1]!=T){T=Time[1];
//---
      Analiz();
      if(fCls==0){AlgOpenClose();}
//---
}
//----
if(OrdersTotal()!=0){Trall();}
if(fCls!=0){Cls();}
}
//+------------------------------------------------------------------+
void LOT(){
    double MaxLOT=0;
    if(AutoProcent!=0){
         MaxLOT=(AccountEquity()/MarketInfo(Symbol(),MODE_MARGINREQUIRED));MaxLOT*=0.99;Lot=(MaxLOT*0.01)*AutoProcent;}
      else{Lot=LotManual;}
      if(Lot<MarketInfo(Symbol(),MODE_MINLOT)){Lot=MarketInfo(Symbol(),MODE_MINLOT);}  
   Lot=NormalizeDouble(Lot,2);}
//---------------------------------   
//Sell ("  ")
//---------------------------------
void S(string Comm=NULL){
   //
   double SL=0,TP=0;
   if(Autotrade==true&&(OrdersType==Buy_and_Sell||OrdersType==Sell_Orders)){
         if(MaxOrders>OrdersTotal()&&SpreadLimit>=SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)){
                  if((MarketInfo(_Symbol,MODE_MARGINREQUIRED)*Lot)<AccountFreeMargin()){
                  if(TakeProfit!=0){TP=SymbolInfoDouble(_Symbol,SYMBOL_BID)-TakeProfitNorm;}else{TP=0;}
                  if(StopLoss!=0){SL=SymbolInfoDouble(_Symbol,SYMBOL_ASK)+StopLossNorm;}else{SL=0;}              
            LOT();int S1=OrderSend(Symbol(),OP_SELL,Lot,Bid,SlipNorm,SL,TP,Comm,MagicNumber,0,clrRed);
                  if(S1<0&&fError<3){S();fError++;Sleep(1000);}}}}}
//---------------------------------
//Buy ("  ")
//---------------------------------
void B(string Comm=NULL){
   //
   double SL=0,TP=0;
   if(Autotrade==true&&(OrdersType==Buy_and_Sell||OrdersType==Buy_Orders)){
         if(MaxOrders>OrdersTotal()&&SpreadLimit>=SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)){
                  if((MarketInfo(_Symbol,MODE_MARGINREQUIRED)*Lot)<AccountFreeMargin()){
                  if(TakeProfit!=0){TP=SymbolInfoDouble(_Symbol,SYMBOL_ASK)+TakeProfitNorm;}else{TP=0;}
                  if(StopLoss!=0){SL=SymbolInfoDouble(_Symbol,SYMBOL_BID)-StopLossNorm;}else{SL=0;}
            LOT();int B1=OrderSend(Symbol(),OP_BUY,Lot,Ask,SlipNorm,SL,TP,Comm,MagicNumber,0,clrBlue);
                  if(B1<0&&fError<3){B();fError++;Sleep(1000);}}}}}
//-------------------------------------------------------------------
void ClsO(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if((OrderType()==2||OrderType()==3||OrderType()==4||OrderType()==5)&&(IsTradeContextBusy()==0)){if (OrderDelete(OrderTicket())==true){}}}}}}}
//------------------------------------------------------------------
void ClsSS(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_SELLSTOP&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}}
//------------------------------------------------------------------
void ClsBS(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_BUYSTOP&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}}  
//------------------------------------------------------------------
void ClsSL(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_SELLLIMIT&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}}
//------------------------------------------------------------------
void ClsBL(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_BUYLIMIT&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}} 
//------------------------------------------------------------------
void ClsB(){for (int u = 0; u <= OrdersTotal()-1; u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if (OrderType() == OP_BUY&&(IsTradeContextBusy()==0)){if(OrderClose(OrderTicket(),OrderLots(),SymbolInfoDouble(_Symbol,SYMBOL_BID),SlipNorm,Green)==true){}}}}}}}
//------------------------------------------------------------------
void ClsS(){for (int u = 0; u <= OrdersTotal()-1; u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if (OrderType() == OP_SELL&&(IsTradeContextBusy()==0)){if(OrderClose(OrderTicket(),OrderLots(),SymbolInfoDouble(_Symbol,SYMBOL_ASK),SlipNorm,Red)==true){}}}}}}}   
//-------------------------------------------------------------------
void Cls(){
   if(fCls==1){if(s!=0){ClsS();}else{fCls=0;}}
   if(fCls==2){if(b!=0){ClsB();}else{fCls=0;}}
    if(fCls==3){if(ss!=0){ClsSS();}else{fCls=0;}}
    if(fCls==4){if(bs!=0){ClsBS();}else{fCls=0;}}
     if(fCls==5){if(sl!=0){ClsSL();}else{fCls=0;}}
     if(fCls==6){if(bl!=0){ClsBL();}else{fCls=0;}}
      if(fCls==7){if(n!=0){ClsS();ClsB();}else{fCls=0;}}
      if(fCls==8){if(no!=0){ClsO();}else{fCls=0;}}
      if(fCls==9){if(nn!=0){ClsS();ClsB();ClsO();}else{fCls=0;}}}      
      //---------------------------------------------------------------------------------
void Trall(){
double Start=0,SL=0,TP=0;
if((StopLoss2!=0||StepT!=0)&&(IsTradeContextBusy()==0)){
   for (int u = OrdersTotal()-1; u >= 0; u--) {
      if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){
         if(OrderMagicNumber() == MagicNumber){   
            if(OrderType()==0){
               Start=OrderOpenPrice()+StopLoss2Norm;
              if(StepT!=0&&StopLoss2!=0&&(MarketInfo(Symbol(),MODE_BID)>Start)){
              SL=MarketInfo(Symbol(),MODE_BID)-StopLoss2Norm-StepTNorm; 
              if(SL > OrderStopLoss()||OrderStopLoss()==0){SL=MarketInfo(Symbol(),MODE_BID)-StopLoss2Norm;if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrSkyBlue)==true){;}}}
                if(StopLoss2!=0&&BU!=0){
                SL=OrderOpenPrice()+BUNorm;
                if((MarketInfo(Symbol(),MODE_BID)>Start)&&(OrderStopLoss()<SL||OrderStopLoss()==0)&&(MarketInfo(Symbol(),MODE_BID)>(SL+(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL)*_Point)))&&(OrderStopLoss()!=SL)){
                if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrSkyBlue)==true){;}}}
                }
            if(OrderType()==1){
              Start=OrderOpenPrice()-StopLoss2Norm;
              if(StepT!=0&&StopLoss2!=0&&(MarketInfo(Symbol(),MODE_ASK)<Start)){
              SL=MarketInfo(Symbol(),MODE_ASK)+StopLoss2Norm+StepTNorm;  
              if(SL < OrderStopLoss()||OrderStopLoss()==0){SL=MarketInfo(Symbol(),MODE_ASK)+StopLoss2Norm;if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrOrange)==true){;}}}
                if(StopLoss2!=0&&BU!=0){
                SL=OrderOpenPrice()-BUNorm;
                if((MarketInfo(Symbol(),MODE_ASK)<Start)&&(OrderStopLoss()>SL||OrderStopLoss()==0)&&(MarketInfo(Symbol(),MODE_ASK)<(SL-(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL)*_Point)))&&(OrderStopLoss()!=SL)){
                if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrSkyBlue)==true){;}}}}}}}}
                }   
//------------------------------------------------------------   
void AlgOpenClose(){
int ok=0;
double adx_0=iADX(NULL,0,PeriodADX,PriceADX,MODE_MAIN,1);
MA1[1]=iMA(NULL,0,MA1Period,0,MA1Method,MA1Price,1);
MA2[1]=iMA(NULL,0,MA2Period,0,MA2Method,MA2Price,1);
MA3[1]=iMA(NULL,0,MA3Period,0,MA3Method,MA3Price,1);
MA1[2]=iMA(NULL,0,MA1Period,0,MA1Method,MA1Price,2);
MA2[2]=iMA(NULL,0,MA2Period,0,MA2Method,MA2Price,2);
MA3[2]=iMA(NULL,0,MA3Period,0,MA3Method,MA3Price,2);
MA1[3]=iMA(NULL,0,MA1Period,0,MA1Method,MA1Price,3);
MA2[3]=iMA(NULL,0,MA2Period,0,MA2Method,MA2Price,3);
MA3[3]=iMA(NULL,0,MA3Period,0,MA3Method,MA3Price,3);
//---
if(ff==1&&MA2[1]>MA3[1]&&MA2[1]<MA1[1]&&(MA2[2]<MA3[2]||MA2[2]>MA1[2])){ff=0;}
if(ff==1&&MA2[1]<MA3[1]&&MA2[1]>MA1[1]&&(MA2[2]>MA3[2]||MA2[2]<MA1[2])){ff=0;}
//Open
if(adx_0>uslADX){ok=1;}else{ok=0;}
if(Close[1]>MA1[1]&&Close[1]>MA2[1]&&Close[1]>MA3[1] && Close[2]>MA1[2]&&Close[2]>MA2[2]&&Close[2]>MA3[2] && Close[3]>MA1[3]&&Close[3]>MA2[3]&&Close[3]>MA3[3] && Open[3]>MA1[3]&&Open[3]>MA2[3]&&Open[3]>MA3[3]){
   if(Open[3]<Open[2]&&Open[2]>Open[1]&&Open[1]<Open[0]){okB=1;okS=0;}}
//--
if(Close[1]<MA1[1]||Close[1]<MA2[1]||Close[1]<MA3[1]){okB=0;}
//---
if(Close[1]<MA1[1]&&Close[1]<MA2[1]&&Close[1]<MA3[1] && Close[2]<MA1[2]&&Close[2]<MA2[2]&&Close[2]<MA3[2] && Close[3]<MA1[3]&&Close[3]<MA2[3]&&Close[3]<MA3[3] && Open[3]<MA1[3]&&Open[3]<MA2[3]&&Open[3]<MA3[3]){
   if(Open[3]>Open[2]&&Open[2]<Open[1]&&Open[1]>Open[0]){okS=1;okB=0;}}
//--
if(Close[1]>MA1[1]||Close[1]>MA2[1]||Close[1]>MA3[1]){okS=0;}
//Buy
if(MA2[1]>MA3[1]&&MA2[1]<MA1[1]&&f==0&&ff==0){
   if(b==0&&ok==1&&okB==1){f=2;B();okB=0;}}
//Sell   
if(MA2[1]<MA3[1]&&MA2[1]>MA1[1]&&f==0&&ff==0){
   if(s==0&&ok==1&&okS==1){f=1;S();okS=0;}}
//---   
if((MA1[1]<MA2[1]||MA2[1]<MA3[1]||MA1[1]<MA3[1])&&f==2){f=0;}
if((MA1[1]>MA2[1]||MA2[1]>MA3[1]||MA1[1]>MA3[1])&&f==1){f=0;}
//Comment(okS," | ",okB);
//--------------------------------------------------------------   
//Close
if(b!=0&&MA2[1]>MA1[1]){fCls=2;}
if(s!=0&&MA1[1]>MA2[1]){fCls=1;}
}
//--------------------      
void Analiz(){
      n=0;nn=0;b=0;s=0;
   if(OrdersTotal()!=0){
      for (int u = 0; u <= OrdersTotal()-1; u++) {
         if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){
            if(OrderMagicNumber() == MagicNumber){
               if(OrderSymbol()==_Symbol){nn++;
   if(OrderType()==0){b++;n++;}
   if(OrderType()==1){s++;n++;}}}}}}}     